## www.cpcwiki.eu-20230926-images.7z

=== bios_december10/Makefile ===
ASM=/Donnees/!SOFTWARE/avra-1.3.0/avra

CPC\ BOOSTER+.hex: booster_main.asm
	$(ASM) -fI -o "CPC BOOSTER+.hex" -d "CPC BOOSTER+.obj" -e "CPC BOOSTER+.eep" -m "CPC BOOSTER+.map" -l "CPC BOOSTER+.lst" "booster_main.asm"
