=== src/inkz80/CMakeLists.txt ===

set(inkZ80_FILES
    inkz80.cpp
    inkz80.h
		)
add_library (inkz80 ${inkZ80_FILES})
