=== src/test/cpc/patrik_z80test/cpc/z80test-1.0/src/Makefile ===
# gmake

NAME = z80test
VERSION = 1.0
PKG := $(NAME)-$(VERSION)

PROGS := z80full z80flags z80doc z80docflags z80ccf z80memptr
SRCS  := main idea crctab tests testmacros print

all: $(addsuffix .dsk,$(PROGS))

.DELETE_ON_ERROR: %.out

%.out : %.asm $(addsuffix .asm,$(SRCS))
	sjasm $<

%.dsk : %.out
	cpcxfs -nd >$@.dsk
	cpcxfs >$@.dsk -p %.out

FILES := Makefile loader.bas $(addsuffix .asm,$(PROGS)) $(addsuffix .asm, $(SRCS))

dist: all
	ln -s .. $(PKG)
	cp *.dsk $(PKG)
	zip ../$(PKG).zip $(addprefix $(PKG)/src/, $(FILES)) $(PKG)/*.txt $(PKG)/*.dsk
	rm $(PKG)/*.dsk
	rm $(PKG)

clean:
	rm -rf *.out *.lst *.dsk

tidy: clean
	rm -rf $(PROGS)
