=== src/arngui/linux/deb/debian/changelog ===
arnold (1.0-0ubuntu1) vivid; urgency=low

  * Initial release

 -- kevin <kev@cpcfreak.co.uk>  Sun, 19 Jul 2015 12:50:38 +0100
